--pretty hacky
GLOBAL.MakeTome("alchemylog",{},"book_sleep",nil,false,nil,{},true)

local function RefreshPages(inst)
	--remove all pages
	inst.pages = {}
	--[[if #inst.pages ~= 0 then
		for i = 1, #inst.pages do
			inst.pages[i] = nil
		end
	end]]
	--add all pages
	for k,v in pairs(inst.KnownData) do
		local p = {}
		p.head = v.fancyname
		p.page = "Depth of effect tree: ".. v.depth
		for _,w in pairs(v.fx) do
			local effstring = "\nEffect ".. w.name
			if w.prefab then
				effstring = effstring .." ".. w.prefab
			end
			effstring = effstring .." lvl ".. w.str
			p.page = p.page .. effstring
		end
		local tagstring = ""
		for l,w in pairs(v.tags) do
			--maybe add a counter for breaks?
			tagstring = tagstring .." ".. l .."(".. w .."),"
		end
		if tagstring ~= "" then
			p.page = p.page .."\nProperties:".. tagstring
		end
		table.insert(inst.pages,p)
	end
end

local function NextDepth(inst,gen,mastergen,alt) --for effect tree depth
	if not alt then return end
	
	local newgen = gen + 1
	if mastergen.depth < newgen then
		mastergen.depth = newgen
	end
	
	for i = 1, #alt do
		if alt[i].alt then
			inst:NextDepth(newgen,mastergen,alt[i].alt)
		end
	end
end

local function AddData(inst,ingr,data)
	--categorize everything
	
	if not inst.KnownData[ingr.prefab] then
		local displayname = ingr:GetDisplayName()
		inst.KnownData[ingr.prefab] = {fancyname = displayname, tags = {}, fx = {}}
		table.insert(inst.toc,{name = displayname, goto = displayname})
	--else just update the fancyname? (preferably before rolling)
	end
	
	local gen = 1
	inst.KnownData[ingr.prefab].depth = gen
	for i = 1, #ingr.components.potionbrewable.fx do
		inst:NextDepth(gen,inst.KnownData[ingr.prefab],ingr.components.potionbrewable.fx[i].alt)
	end
	
	
	if not (data and type(data) == "table") then return false end
	
	if data.key then
		inst.KnownData[ingr.prefab].tags[data.key] = data.val
	else
		local pack = {name = data.name, str = data.strength} --, anti = data.anti
		if data.args and data.args.prefab then
			pack.prefab = data.args.prefab
		end
		table.insert(inst.KnownData[ingr.prefab].fx,pack)
	end
	
	--regenerate that page
	inst:RefreshPages()
	
	--remove ingredient
	if ingr.components.stackable then
		ingr.components.stackable:Get():Remove()
	else
		ingr:Remove()
	end
	return true
end

local function RollData(inst,ingr)
	local guy = GLOBAL.GetPlayer() --change this
	
	if not ingr.components.potionbrewable or #ingr.components.potionbrewable.fx == 0
	or ingr:HasTag("irreplacable") then
		guy.components.talker:Say(GLOBAL.GetString(guy.prefab, "ANNOUNCE_NO_INGREDIENT"))
		return false
	end
	
	local candidates = {}
	
	--get a list of existing effects
	local knownfx = {}
	if inst.KnownData[ingr.prefab] then
		for i = 1, #inst.KnownData[ingr.prefab].fx do
			print("FOLLOWING EFFECT IS KNOWN: ",inst.KnownData[ingr.prefab].fx[i].name)
			knownfx[inst.KnownData[ingr.prefab].fx[i].name] = true
			--of course there are ingredients with duplicates, but why list things twice?
		end
	end
	
	for i = 1, #ingr.components.potionbrewable.fx do
		print("TESTING EFFECT",ingr.components.potionbrewable.fx.name)
		if not knownfx[ingr.components.potionbrewable.fx[i].name] then
			print("ADDED")
			table.insert(candidates,ingr.components.potionbrewable.fx[i])
		end
	end
	
	if ingr.components.potionbrewable.tags then
		for k,v in pairs(ingr.components.potionbrewable.tags) do
			if not (inst.KnownData[ingr.prefab]
			and inst.KnownData[ingr.prefab].tags[k]) then
				table.insert(candidates,{key = k, val = v})
			else
				inst.KnownData[ingr.prefab].tags[k] = v --update
			end
		end
	end
	
	if #candidates == 0 then
		guy.components.talker:Say(GLOBAL.GetString(guy.prefab, "ANNOUNCE_KNOWN_INGREDIENT"))
		if GLOBAL.GetWorld().components.feattrigger then --Feats
			GLOBAL.GetWorld().components.feattrigger:Trigger("AlchemyLogFull")
		end
		return false
	end
	
	local pick = candidates[math.random(#candidates)]
	
	return inst:AddData(ingr,pick)
end

local function OnSave(inst,data)
	data.known = inst.KnownData
end

local function OnLoad(inst,data)
	if data then
		inst.KnownData = data.known or {}
		--rebuild ToC
		for k,v in pairs(inst.KnownData) do
			table.insert(inst.toc,{name = v.fancyname, goto = v.fancyname})
		end
		inst:RefreshPages()
	end
end

AddPrefabPostInit("alchemylog",function(inst)
	GLOBAL.MakeSmallBurnable(inst)
	GLOBAL.MakeSmallPropagator(inst)
	
	inst:RemoveTag("irreplacable")
	
	inst.KnownData = {}
	inst.toc = {} --so it's not the shared one
	
	inst.NextDepth = NextDepth
	inst.RollData = RollData
	inst.AddData = AddData
	inst.RefreshPages = RefreshPages
	
	--we don't really need to save the current page, but future-proofinessity
	local oldfn = inst.OnSave
	inst.OnSave = function(inst,data)
		oldfn(inst,data)
		OnSave(inst,data)
	end
	oldfn = inst.OnLoad
	inst.OnLoad = function(inst,data)
		oldfn(inst,data)
		OnLoad(inst,data)
	end
	
	--interact with ingredients
	inst:AddComponent("container")
	inst.components.container:SetNumSlots(1)
	inst.components.container.acceptsstacks = false
	inst.components.container.type = "temp"
	inst.components.container.widgetslotpos = {GLOBAL.Vector3(0,0,0)}
	inst.components.container.widgetpos = GLOBAL.Vector3(0,600,0)
	inst.components.container.side_align_tip = 100
	inst.components.container.onopenfn = function(inst)
		inst.components.container:Close()
		inst.components.container:DropEverything()
	end
	inst:ListenForEvent("itemget",function(inst,data)
		item = data.item or inst.components.container.slots[1]
		if not inst:RollData(item) then
			inst.components.container:DropItem(item)
		end
		if GLOBAL.GetWorld().components.feattrigger then --Feats of the World support
			if #inst.toc >= 5 then --using ToC is kinda cheaty
				GLOBAL.GetWorld().components.feattrigger:Trigger("AlchemyLog2")
				GLOBAL.GetWorld().components.feattrigger:Trigger("AlchemyLog3",true)
			end
			if #inst.toc >= 12 then
				GLOBAL.GetWorld().components.feattrigger:Trigger("AlchemyLog3")
				GLOBAL.GetWorld().components.feattrigger:Trigger("AlchemyLog4",true)
			end
			if #inst.toc >= 25 then
				GLOBAL.GetWorld().components.feattrigger:Trigger("AlchemyLog4")
				GLOBAL.GetWorld().components.feattrigger:Trigger("AlchemyLog5",true)
			end
			if #inst.toc >= 40 then
				GLOBAL.GetWorld().components.feattrigger:Trigger("AlchemyLog5")
			end
		end
	end)
	
	--Feats of the World support
	inst:DoTaskInTime(0,function()
		if GLOBAL.GetWorld().components.feattrigger then
			GLOBAL.GetWorld().components.feattrigger:Trigger("AlchemyLog1")
			GLOBAL.GetWorld().components.feattrigger:Trigger("AlchemyLog2",true)
			GLOBAL.GetWorld().components.feattrigger:Trigger("AlchemyLogFull",true)
		end
	end)
end)
