local RoG = GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS)

--Soul items have their effects added directly

----------------------------------------------------------------------------------------------
--INGREDIENT POST-INITS
----------------------------------------------------------------------------------------------

local function meat(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Temperature",2,{val=10})
	inst.components.potionbrewable:AddEffect("dummy",0,nil,nil,{ --illustrative example for dummy effects
		Poison = true,
		Ice = true,
	},{
		{name="Fire",strength=2}
	})
	inst.components.potionbrewable.tags = {blood = 1}
	return inst
end
AddPrefabPostInit("meat",meat)

--

local function spidergland(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Heal",1,{val=15})
	return inst
end
AddPrefabPostInit("spidergland",spidergland)

--

local function berries(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Heal",0,{val=5})
	inst.components.potionbrewable:AddEffect("Ice",1,{val=1},nil,{
		Acid = true,
		RunSpeed = true,
		Insanity = true,
	},{
		{name="RunSpeed",strength=2,args={val=3},dur=70}
	})
	inst.components.potionbrewable.tags = {poop = 1}
	return inst
end
AddPrefabPostInit("berries",berries)

--

local function monstermeat(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Damage",0,{val=-10},nil,nil,{
		{name="Damage",strength=3,args={val=-30}}
	})
	inst.components.potionbrewable.tags = {blood = 1}
	return inst
end
AddPrefabPostInit("monstermeat",monstermeat)

--

local function honey(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Regen",1,{rate=2},21)
	return inst
end
AddPrefabPostInit("honey",honey)

--

local function wormlight(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Light",3,{dur=120},120)
	inst.components.potionbrewable:AddEffect("CombatStrength",1,{val=6},60,{
		Regen = true,
		Heal = true,
	},{
		{name="Insanity",strength=2,dur=40}
	})
	inst.components.potionbrewable.tags = {blood = 0, precious = 1}
	return inst
end
AddPrefabPostInit("wormlight",wormlight)

--

local function mandrake(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Sleep",3,{val=5},{
		Acid = true,
	},{
		{name="Fire",strength=1}
	})
	inst.components.potionbrewable:AddEffect("Regen",0,nil,5,{
		Acid = true,
	})
	inst.components.potionbrewable.tags = {mandrake = 4}
	return inst
end
AddPrefabPostInit("mandrake",mandrake)

--

local function red_cap(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Heal",2,{val=20},nil,{
		Poison = true,
	},{
		{name="Fire",strength=3}
	})
	return inst
end
AddPrefabPostInit("red_cap",red_cap)

--

local function green_cap(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Regen",2,{val=2},10,{
		Damage = true,
	},{
		{name="Insanity",strength=7,dur=140}
	})
	return inst
end
AddPrefabPostInit("green_cap",green_cap)

--

local function blue_cap(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Heal",2,{val=25},nil,{
		Poison = true,
		RunSpeed = true,
	},{
		{name="Sleep",strength=2,args={val=2}}
	})
	return inst
end
AddPrefabPostInit("blue_cap",blue_cap)

--

local function durian(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Acid",0,nil,3,{
		Fire = true,
	})
	inst.components.potionbrewable:AddEffect("RunSpeed",1,{val=1},15)
	inst.components.potionbrewable.tags = {poop = 3}
	return inst
end
AddPrefabPostInit("durian",durian)

--

local function pomegranate(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Temperature",3,{val=-15},{
		Poison = true,
		Invisible = true,
	})
	inst.components.potionbrewable:AddEffect("Regen",1,{rate=1.5},13,{
		Invisible = true,
	},{
		{name="CombatStrength",strength=5,args={val=-20},dur=80,anti={ --this makes your punches inverted :P
			RunSpeed = true,
		},alt={
			{name="Heal",strength=5,args={val=70}}
		}}
	})
	return inst
end
AddPrefabPostInit("pomegranate",pomegranate)

--

local function corn(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Temperature",2,{val=10},nil,{
		Insanity = true,
		Fire = true,
		Explode = true,
		Hover = true,
	},{
		{name="Temperature",strength=4,args={val=25}}
	})
	inst.components.potionbrewable.tags = {poop = 1}
	return inst
end
AddPrefabPostInit("corn",corn)

--

local function dragonfruit(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Heal",1,{val=15},nil,{
		Ice = true,
		Temperature = true,
	})
	inst.components.potionbrewable:AddEffect("Fire",1,nil,nil,{
		Temperature = true,
	},{
		{name="Sleep",strength=1,args={val=1}}
	})
	return inst
end
AddPrefabPostInit("dragonfruit",dragonfruit)

--

local function pumpkin(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Temperature",1,{val=-5},nil,{
		Insanity = true,
		Shield = true,
		Blink = true,
		Ghost = true,
	},{
		{name="Light",strength=1,args={dur=30},dur=30}
	})
	return inst
end
AddPrefabPostInit("pumpkin",pumpkin)

--

local function eggplant(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Damage",1,{val=-10})
	inst.components.potionbrewable:AddEffect("Regen",1,nil,10,{
		Temperature = true,
	},{
		{name="Ice",strength=6,args={val=7},anti={
				Explode = true,
			},alt={
				{name="Shield",strength=2,args={val=.25},dur=40} --EDIT once set up, add sleepimmune
			}
		}
	})
	inst.components.potionbrewable.tags = {poop = 1}
	return inst
end
AddPrefabPostInit("eggplant",eggplant)

--

local function carrot(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("IceImmune",1,{shields = 1},30)
	inst.components.potionbrewable:AddEffect("Slip",0,nil,nil,{
		Blink = true,
		Ghost = true,
		Damage = true,
	},{
		{name="Invisible",strength=3,dur=25,anti={
			Summon = true,
			Insanity = true,
		}},
	})
	inst.components.potionbrewable.tags = {mandrake = 1}
	return inst
end
AddPrefabPostInit("carrot",carrot)

--

local function pinecone(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Shield",1,{val=.1,shields = 1},50)
	inst.components.potionbrewable:AddEffect("CombatStrength",1,{val=-5},15,{
		CombatStrength = true,
		Ice = true,
		Blind = true,
	},{
		{name="Summon",strength=2,args={prefab="leif"}}
	})
	inst.components.potionbrewable.tags = {seed = 2}
	return inst
end
AddPrefabPostInit("pinecone",pinecone)

--

local function cave_banana(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("CombatStrength",3,{val=20},35,{
		RunSpeed = true,
		IceImmune = true,
		FireImmune = true,
		Shield = true,
	},{
		{name="Blind",strength=1,args={alpha=.6},dur=5},
		{name="Summon",strength=2,args={prefab="monkey"}},
	})
	inst.components.potionbrewable.tags = {poop = 1}
	return inst
end
AddPrefabPostInit("cave_banana",cave_banana)

--

local function petals(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Blind",2,{alpha=.9},8,{
		Sleep = true,
		RunSpeed = true,
		GrueImmune = true,
	})
	inst.components.potionbrewable:AddEffect("dummy",0,nil,nil,{
		Poison = true,
		Shield = true,
	},{
		{name="Blink",strength=3},
		{name="Explode",strength=0,args={instant=true,dmg=60},anti={
			FireImmune = true,
			Poison = true,
			Temperature = true,
		}},
	})
	inst.components.potionbrewable.tags = {seed = 1}
	return inst
end
AddPrefabPostInit("petals",petals)

--

local function petals_evil(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Insanity",1,nil,20,{
		Light = true,
		Invisible = true,
	})
	inst.components.potionbrewable:AddEffect("Summon",1,{prefab="terrorbeak"},nil,{
		Light = true,
		Invisible = true,
	})
	inst.components.potionbrewable:AddEffect("Ice",2,{val=2})
	inst.components.potionbrewable:AddEffect("Blink",0,{minr=2,maxr=4})
	inst.components.potionbrewable.tags = {shadow = 2, seed = 1}
	return inst
end
AddPrefabPostInit("petals_evil",petals_evil)

--

local function stinger(inst)
	--A bit concerning, since there can be tons of stingers on the ground
	--But unlike seeds or rot, this doesn't appear naturally in large quantities
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Poison",2,nil,12,{
		CombatStrength = true,
		GrueImmune = true,
		Ice = true,
	},{
		{name="Thorns",strength=3,dur=40}
	})
	inst.components.potionbrewable:AddEffect("CombatStrength",0,{val=-2},20)
	inst.components.potionbrewable.tags = {spiky = 2}
	return inst
end
AddPrefabPostInit("stinger",stinger)

--

local function feather_crow(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Sleep",2,{val=2})
	inst.components.potionbrewable:AddEffect("Colour",1,{r=.5,g=0,b=1},24,{
		FireImmune = true,
	})
	inst.components.potionbrewable.tags = {bird = 1,metal = 0} --hack so it only "enables" metal
	return inst
end
AddPrefabPostInit("feather_crow",feather_crow)

--

local function feather_robin_winter(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("IceImmune",2,nil,42,{
		Thorns = true,
		Fire = true,
	},{
		{name="Ice",strength=3,args={val=3}}
	})
	inst.components.potionbrewable.tags = {bird = 2, precious = 1}
	return inst
end
AddPrefabPostInit("feather_robin_winter",feather_robin_winter)

--

local function feather_robin(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("FireImmune",2,nil,20,{
		IceImmune = true,
		Slip = true,
		Light = true,
	},{
		{name="GrueImmune",strength=1,dur=60}
	})
	inst.components.potionbrewable:AddEffect("Colour",2,{r=.2,g=.2,b=.2},18,{
		IceImmune = true,
		Slip = true,
		Light = true,
	})
	inst.components.potionbrewable.tags = {bird = 2}
	return inst
end
AddPrefabPostInit("feather_robin",feather_robin)

--

local function beardhair(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("CombatStrength",2,{val=14},30,{
		Thorns = true,
	},{
		{name="Invisible",strength=2,dur=18}
	})
	inst.components.potionbrewable.tags = {hair = 3}
	return inst
end
AddPrefabPostInit("beardhair",beardhair)

--

local function beefalowool(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Temperature",3,{val=15})
	inst.components.potionbrewable:AddEffect("IceImmune",1,{shields=1},25,{
		Blink = true,
		RunSpeed = true,
	},{
		{name="Shield",strength=3,dur=40,args={val=.5,shields=3},anti={Ice=true}},
		{name="Slip",strength=2,anti={Ice=true}}
	})
	inst.components.potionbrewable.tags = {hair = 2}
	return inst
end
AddPrefabPostInit("beefalowool",beefalowool)

--

local function tentaclespots(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Acid",2,{rate=.5},5,{
		Poison = true,
	},{
		{name="Insanity",strength=4,dur=68,anti={
			GrueImmune=true,
			Explode=true,
		}},
		{name="Blind",strength=4,args={alpha=.7},dur=68,anti={
			GrueImmune=true,
			Explode=true,
		}}
	})
	inst.components.potionbrewable:AddEffect("RunSpeed",3,{val=4},25)
	inst.components.potionbrewable:AddEffect("FireImmune",3,{shields=3},44)
	inst.components.potionbrewable.tags = {tentacle = 3, precious = 1}
	return inst
end
AddPrefabPostInit("tentaclespots",tentaclespots)

--

local function livinglog(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Ice",4,{val=5},nil,{
		Sleep = true,
		Insanity = true,
	},{
		{name="Poison",strength=4,args={val=-1.5},dur=24}
	})
	inst.components.potionbrewable:AddEffect("Colour",3,{r=.5,g=1,b=.3},25)
	inst.components.potionbrewable:AddEffect("RunSpeed",2,{val=-2},32)
	inst.components.potionbrewable.tags = {shadow = 1}
	return inst
end
AddPrefabPostInit("livinglog",livinglog)

--

local function tallbirdegg(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Heal",3,{val=24})
	inst.components.potionbrewable:AddEffect("FireImmune",3,{shields=3},60,{
		Fire = true,
		Shield = true,
	},{
		{name="Temperature",strength=5,args={val=-28}},
		{name="Light",strength=2,args={dur=70},dur=70}
	})
	inst.components.potionbrewable:AddEffect("dummy",0,nil,nil,{
		Blink = true,
		Thorns = true,
		Damage = true,
	},{
		{name="Summon",strength=2,args={prefab="tallbird"}}
	})
	inst.components.potionbrewable.tags = {bird = 2, precious = 1}
	return inst
end
AddPrefabPostInit("tallbirdegg",tallbirdegg)

--

local function nitre(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Damage",2,{val=-15},nil,{
		Explode = true,
		CombatStrength = true,
	},{
		{name="GrueImmune",strength=4,args={shields=4},dur=127,anti={
			Invisible=true
		}}
	})
	inst.components.potionbrewable.tags = {metal = 1}
	return inst
end
AddPrefabPostInit("nitre",nitre)

--

local function ash(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("dummy",0,nil,nil,{
		Heal = true,
		Poison = true,
		Slip = true,
	},{
		{name="Regen",strength=3,args={val=3},dur=8},
		{name="Fire",strength=2}
	})
	return inst
end
AddPrefabPostInit("ash",ash)

--

local function gunpowder(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Explode",3,{dmg=10, fire=true},13,{
		FireImmune = true,
		Regen = true,
	},{
		{name="Acid",strength=2,args={rate=1.5},dur=12}
	})
	inst.components.potionbrewable:AddEffect("IceImmune",2,nil,40,{
		Shield = true,
		Acid = true
	})
	inst.components.potionbrewable:AddEffect("Summon",1,{prefab="slurtleslime"},nil,{
		Regen = true,
		Insanity = true,
		Light = true,
		Blink = true,
	},{
		{name="Slip",strength=2}
	})
	return inst
end
AddPrefabPostInit("gunpowder",gunpowder)

--

local function butterflywings(inst) --TODO
	inst:AddComponent("potionbrewable")
	--inst.components.potionbrewable:AddEffect("Hover",1,nil,15)
	return inst
end
--AddPrefabPostInit("butterflywings",butterflywings)

--

local function pigskin(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("dummy",0,nil,nil,{
		Acid = true,
		Fire = true,
		FireImmune = true,
		Sleep = true,
	},{
		{name="FireImmune",strength=6,args={shields=5},dur=250},
		{name="Damage",strength=2,args={val=-12},anti={Ice=true}}
	})
	inst.components.potionbrewable:AddEffect("Colour",2,{r=1,g=.6,b=.7},40)
	inst.components.potionbrewable:AddEffect("Heal",1,{val=6})
	inst.components.potionbrewable.tags = {blood = 1}
	return inst
end
AddPrefabPostInit("pigskin",pigskin)

--

local function manrabbit_tail(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("RunSpeed",5,{val=6},40,{
		Acid = true,
		Invisible = true,
		Damage = true,
	},{
		{name="Blind",strength=4,args={alpha=1},dur=10}
	})
	inst.components.potionbrewable:AddEffect("Colour",1,{a=.9},30,{
		Acid = true,
		Invisible = true,
		Damage = true,
	},{
		{name="Shield",strength=4,args={val=.65,shields=4},dur=16}
	})
	inst.components.potionbrewable.tags = {precious = 1}
	return inst
end
AddPrefabPostInit("manrabbit_tail",manrabbit_tail)

--

local function cutreeds(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Thorns",1,nil,14,{
		Poison = true,
		Fire = true,
		Sleep = true,
		Slip = true,
		Explode = true,
	},{
		{name="Blink",strength=4,args={minr=14,maxr=18}},
		{name="CombatStrength",strength=3,args={val=18},dur=46,anti={
			Temperature = true,
			Light = true,
		},alt={
			{name="Summon",strength=4,args={prefab="tentacle"}}
		}}
	})
	return inst
end
AddPrefabPostInit("cutreeds",cutreeds)

--

local function cutlichen(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Damage",1,{val=-5})
	inst.components.potionbrewable:AddEffect("Insanity",1,nil,20,{
		Fire = true,
		Explode = true,
	},{
		{name="Thorns",strength=2,dur=25},
		{name="Acid",strength=2,args={val=2},dur=5},
		{name="Temperature",strength=3,args={val=20}}
	})
	inst.components.potionbrewable.tags = {tentacle = 1,metal = 1}
	return inst
end
AddPrefabPostInit("cutlichen",cutlichen)

--

local function charcoal(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("RunSpeed",1,{val=2},40)
	inst.components.potionbrewable:AddEffect("Poison",1,{val=1.5},4,{
		Acid = true,
		IceImmune = true,
		CombatStrength = true,
	},{
		{name="Slip",strength=4,anti={
			Slip = true,
			Summon = true,
		},alt={
			{name="IceImmune",strength=4,args={shields=4},dur=170}
		}}
	})
	return inst
end
AddPrefabPostInit("charcoal",charcoal)

--

local function honeycomb(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Summon",1,{prefab="killerbee"},nil,{
		Fire = true,
	})
	inst.components.potionbrewable:AddEffect("Summon",1,{prefab="killerbee"},nil,{
		Fire = true,
	})
	inst.components.potionbrewable:AddEffect("Thorns",4,nil,58,{
		Invisible = true,
		Regen = true,
		RunSpeed = true,
	},{
		{name="Temperature",strength=7,args={val=65},anti={
			Shield = true,
		}},
		{name="Colour",strength=7,args={r=1,g=.6,b=.2},dur=15,anti={
			Shield = true,
		}}
	})
	return inst
end
AddPrefabPostInit("honeycomb",honeycomb)

--

local function tentaclespike(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Thorns",2,nil,23,{
		Slip = true,
		Light = true,
		Regen = true,
	},{
		{name="Blind",strength=3,args={alpha=.85},dur=38,anti={
			Invisible = true,
			CombatStrength = true,
		}},
		{name="Shield",strength=3,dur=44,args={val=.55,shields=3},anti={
			Invisible = true,
		}},
	})
	inst.components.potionbrewable:AddEffect("CombatStrength",2,{val=15},28,{
		Slip = true,
		Light = true,
		Regen = true,
	})
	inst.components.potionbrewable.tags = {tentacle = 3, spiky = 1}
	return inst
end
AddPrefabPostInit("tentaclespike",tentaclespike)

--

local function lureplantbulb(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Summon",2,{prefab="eyeplant"})
	inst.components.potionbrewable:AddEffect("Slip",4)
	inst.components.potionbrewable:AddEffect("Fire",3,nil,nil,{
		IceImmune = true,
		Blind = true,
	})
	inst.components.potionbrewable:AddEffect("Regen",3,{rate=1.5},40,{
		IceImmune = true,
		Blind = true,
	},{
		{name="Light",strength=4,args={dur=135},dur=135,anti={
			Damage = true,
			Poison = true,
		}},
	})
	inst.components.potionbrewable.tags = {seed = 1}
	return inst
end
AddPrefabPostInit("lureplantbulb",lureplantbulb)

--

local function plantmeat(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("GrueImmune",2,nil,94,{
		IceImmune = true,
		RunSpeed = true,
	},{
		{name="Invisible",strength=1,dur=12,anti={
			Poison = true,
			GrueImmune = true,
		}},
	})
	inst.components.potionbrewable:AddEffect("Poison",1,{val=2,rate=2},17,{
		RunSpeed = true,
	})
	inst.components.potionbrewable.tags = {poop = 2}
	return inst
end
AddPrefabPostInit("plantmeat",plantmeat)

--

local function mosquitosack(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Shield",2,{val=.3},11,{
		RunSpeed = true,
		Insanity = true,
		Summon = true,
	})
	inst.components.potionbrewable:AddEffect("FireImmune",3,{shields=3},38,{
		RunSpeed = true,
		Insanity = true,
		Summon = true,
	},{
		{name="Temperature",strength=4,args={val=24},anti={
			Heal = true,
			Sleep = true,
		}},
	})
	inst.components.potionbrewable:AddEffect("Colour",3,{r=1,g=.1,b=.1},10)
	inst.components.potionbrewable.tags = {blood = 2, metal = 0}
	return inst
end
AddPrefabPostInit("mosquitosack",mosquitosack)

--

local function nightmarefuel(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Blink",9,{minr=24,maxr=46},nil,{
		Acid = true,
		Ice = true,
		Explode = true,
		Summon = true,
		Damage = true,
	},{
		{name="Ice",strength=4,args={val=4},anti={
			Explode=true,
			Acid=true,
		}},
	})
	inst.components.potionbrewable:AddEffect("Insanity",9,nil,200)
	inst.components.potionbrewable.tags = {shadow = 3}
	return inst
end
AddPrefabPostInit("nightmarefuel",nightmarefuel)

--cooked versions of above ingredients

--ROG ONLY--
if RoG then

local function glommerfuel(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("RunSpeed",5,{val=10},24,{
		Ice = true,
		Blind = true,
		Blink = true,
	},{
		{name="Heal",strength=5,args={val=42},anti={
			Fire = true,
			Regen = true,
			Shield = true,
		}},
	})
	inst.components.potionbrewable:AddEffect("CombatStrength",5,{val=-30},22,{
		Fire = true,
		Regen = true,
		Shield = true,
	},{
		{name="Insanity",strength=5,dur=96,anti={
			Ice = true,
			Blind = true,
			Blink = true,
		}},
	})
	inst.components.potionbrewable.tags = {precious = 1}
	return inst
end
AddPrefabPostInit("glommerfuel",glommerfuel)

--

local function coontail(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Sleep",1,{val=1},nil,{
		FireImmune = true,
		Blink = true,
	},{
		{name="RunSpeed",strength=3,args={val=3},dur=54,anti={
			Light = true,
			Thorns = true,
		},alt={
			{name="Blind",strength=5,args={alpha=.95},dur=16},
			{name="Summon",strength=3,args={prefab="catcoonden"}},
		}}
	})
	inst.components.potionbrewable:AddEffect("GrueImmune",3,nil,99)
	inst.components.potionbrewable.tags = {blood = 1}
	return inst
end
AddPrefabPostInit("coontail",coontail)

--

local function ice(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("FireImmune",2,nil,35,{
		Heal = true,
		Poison = true,
		Insanity = true,
	},{
		{name="Slip",strength=1,anti={
			Ice = true,
			Insanity = true,
		}}
	})
	inst.components.potionbrewable:AddEffect("Temperature",4,{val=-22})
	return inst
end
AddPrefabPostInit("ice",ice)

--

local function cactus_meat(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Poison",2,{rate=2},27,{
		Ice = true,
		Sleep = true,
		Explode = true,
		FireImmune = true,
	},{
		{name="Heal",strength=4,args={val=45},anti={
			Fire = true,
			Blind = true,
			Shield = true,
		}},
		{name="Insanity",strength=2,dur=28,anti={
			Fire = true,
			Blind = true,
			Shield = true,
		},alt={
			{name="Thorns",strength=9,dur=130}, 
		}}
	})
	return inst
end
AddPrefabPostInit("cactus_meat",cactus_meat)

--

local function cactus_flower(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Regen",2,{val = 1.5},7)
	inst.components.potionbrewable:AddEffect("Light",2,{dur=54},54,{
		Poison = true,
		Colour = true,
	},{
		{name="RunSpeed",strength=2,args={val=3},dur=17,anti={
			Damage = true,
			Sleep = true,
			Light = true,
		},alt={
			{name="Blink",strength=7,args={minr=32,maxr=40}},
		}}
	})
	return inst
end
AddPrefabPostInit("cactus_flower",cactus_flower)

--

local function boneshard(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Shield",2,{val=.2},32,{
		Blind = true,
		Temperature = true,
		Blink = true,
	})
	inst.components.potionbrewable:AddEffect("Acid",3,nil,28,{
		Blind = true,
		Temperature = true,
		Blink = true,
	},{
		{name="CombatStrength",strength=4,args={val=21},dur=62,anti={ --summon skellies?
			Insanity = true,
			Shield = true,
			Regen = true,
		},alt={
			{name="Explode",strength=255,args={dmg=500},dur=8},
			{name="Shield",strength=255,args={val=1,shields=6},dur=7},
		}}
	})
	inst.components.potionbrewable:AddEffect("GrueImmune",1,nil,38)
	return inst
end
AddPrefabPostInit("boneshard",boneshard)

--

local function acorn(inst)
	inst:AddComponent("potionbrewable")
	inst.components.potionbrewable:AddEffect("Fire",1,nil,nil,{
		IceImmune = true,
		Summon = true,
		RunSpeed = true,
	})
	inst.components.potionbrewable:AddEffect("Invisible",2,nil,20,{
		IceImmune = true,
		Summon = true,
		RunSpeed = true,
	},{
		{name="Invisible",strength=1,nil,dur=8,anti={
			CombatStrength = true,
		}},
		{name="FireImmune",strength=1,args={shields=1},dur=20,anti={
			CombatStrength = true,
		}}
	})
	inst.components.potionbrewable.tags = {seed = 3}
	return inst
end
AddPrefabPostInit("acorn",acorn)

--

local function lightninggoathorn(inst)
	inst:AddComponent("potionbrewable") --well, it's annoying to acquire, so you know... 
	inst.components.potionbrewable:AddEffect("RunSpeed",0,{val=-.5},74,{
		Fire = true,
		Invisible = true,
	})
	inst.components.potionbrewable:AddEffect("CombatStrength",3,{val=22},72,{
		Fire = true,
		Invisible = true,
	},{
		{name="Temperature",strength=5,args={val=30},anti={
			GrueImmune = true,
		}},
		{name="Thorns",strength=3,dur=41,anti={
			GrueImmune = true,
		}},
		{name="Blind",strength=1,args={alpha=.5},dur=28,anti={
			GrueImmune = true,
		}}
	})
	inst.components.potionbrewable:AddEffect("IceImmune",1,nil,14,{
		Thorns = true,
		Shield = true,
		Heal = true,
	})
	inst.components.potionbrewable:AddEffect("Damage",2,{val=-17},nil,{
		Thorns = true,
		Shield = true,
	},{
		{name="Ice",strength=3,args={val=3},anti={
			Blink = true,
			Slip = true,
		}},
		{name="Heal",strength=3,args={val=33},anti={
			Blink = true,
			Slip = true,
		}}
	})
	return inst
end
AddPrefabPostInit("lightninggoathorn",lightninggoathorn)

end

--thatmodname only (concept)
--[[if mods_id.thatmodname then
	local function prefab(inst)
		inst:AddComponent("potionbrewable")
		inst.components.potionbrewable:AddEffect("dummy",strength,args,duration,{
			SOLUTION = true,
		},{
			{name="dummy",strength=0,args={val=0},dur=0,anti={
				SOLUTION = true,
			},alt={
				{name="dummy",strength=0,args={val=0},dur=0}
			}}
		})
		return inst
	end
	AddPrefabPostInit("prefab",prefab)
end]]