--Mod entirely by Mobbstar
--Well, most textures are by Klei
--Okay, and the candle image is by LampOfUlmine
--Fine, and the alkahest image is by fruitloop
--Guilty as charged, the runes and runestone are sketched by Mister L
--Before I forget, the boss theme 1 is by Kevin MacLeod

----------------------------------------------------------------------------------------------
--BASIC VARIABLES
----------------------------------------------------------------------------------------------

Assets = {
	Asset("ATLAS","images/alchemypotion.xml"),
	Asset("IMAGE","images/alchemypotion.tex"),
	Asset("ATLAS","images/destiller.xml"),
	Asset("IMAGE","images/destiller.tex"),
	Asset("ATLAS","images/potiongun.xml"),
	Asset("IMAGE","images/potiongun.tex"),
	Asset("ATLAS","images/alchemysolvant.xml"),
	Asset("IMAGE","images/alchemysolvant.tex"),
	
	Asset("ATLAS","images/soul/soulitem.xml"),
	Asset("IMAGE","images/soul/soulitem.tex"),
	Asset("ATLAS","images/soul/soulitem_giant.xml"),
	Asset("IMAGE","images/soul/soulitem_giant.tex"),
	Asset("ATLAS","images/soul/researchlab_soul_item.xml"),
	Asset("IMAGE","images/soul/researchlab_soul_item.tex"),
	Asset("ATLAS","images/soul/dreamcatcher_item.xml"),
	Asset("IMAGE","images/soul/dreamcatcher_item.tex"),
	Asset("ATLAS","images/soul/hungryheart.xml"),
	Asset("IMAGE","images/soul/hungryheart.tex"),
	Asset("ATLAS","images/soul/starfisher.xml"),
	Asset("IMAGE","images/soul/starfisher.tex"),
	Asset("ATLAS","images/soul/soulhat.xml"),
	Asset("IMAGE","images/soul/soulhat.tex"),
	Asset("ATLAS","images/soul/armorsoul.xml"),
	Asset("IMAGE","images/soul/armorsoul.tex"),
	Asset("ATLAS","images/soul/resurrectionlapis_item.xml"),
	Asset("IMAGE","images/soul/resurrectionlapis_item.tex"),
	Asset("ATLAS","images/soul/spellcandle.xml"),
	Asset("IMAGE","images/soul/spellcandle.tex"),
	
	Asset("SOUNDPACKAGE","sound/soulfulalchemy.fev"),
	Asset("SOUND","sound/soulfulalchemy_bank04.fsb"),
	
	--Asset("SHADER", "shaders/anim_souls.ksh"),
	--Asset("IMAGE","images/colour_cubes/test_cc.tex"),
}

PrefabFiles = {
	"potionmanager", --sadly needed, new in 1.1
	"alchemydistiller",
	"alchemypotion",
	"alchemybottle", --new in 2.0
	"alchemysolvant", --new in 2.1
	"potiongun", --new in 1.1
	"potionreader", --new in 1.2
	"mandrake_seeds",
	"shieldfx",
	"midaspotion", --new in 1.2
	"starpotion", --new in 1.2
	"soulbombpotion", --new in 2.0
	"bottledelements", --new in 2.0 & 2.1
	
	--new in 2.0
	"soulbite",
	"soulitem",
	"researchlab_soul",
	"dreamcatcher",
	"hungryheart",
	"starfisher",
	"soulhat",
	"armorsoul",
	"soulguard",
	"soulfood",
	"resurrectionlapis",
	"spellcandle",
	
	--new in 2.2
	"eldereye",
	"hidingblindfold",
	"runicprojectile",
	"runefx",
	
	--"shadertest",
}

--bringing global stuff into the mod environment
local require = GLOBAL.require
--local AddIngredientValues = GLOBAL.AddIngredientValues
--local AddCookerRecipe = GLOBAL.AddCookerRecipe
local PotionManager --handled in the simpostinit
local TUNING = GLOBAL.TUNING
local TECH = GLOBAL.TECH
local RECIPETABS = GLOBAL.RECIPETABS
local ACTIONS = GLOBAL.ACTIONS
local FRAMES = GLOBAL.FRAMES
local ANCHOR_MIDDLE = GLOBAL.ANCHOR_MIDDLE
local Ents = GLOBAL.Ents
local TimeEvent = GLOBAL.TimeEvent
local Recipe = GLOBAL.Recipe
local SpawnPrefab = GLOBAL.SpawnPrefab

----------------------------------------------------------------------------------------------

GLOBAL.CFG_SA = {
	PotionSanity = GetModConfigData("sanity") * -TUNING.SANITY_TINY,
	DumpEffects = GetModConfigData("dump_pfx"),
	PotionVar = GetModConfigData("diff"),
	SoftRec = GetModConfigData("softrec"),
	
	ELDEREYE_PLAYERDAMAGE = .5,
	ELDEREYE_SHOTDAMAGE = 80,
	ELDEREYE_RAMDAMAGE = 130,
}
local brewer_lvl = GetModConfigData("brewer_lvl")

--the following is a stupid debugprint system
if GetModConfigData("dbug") then
	GLOBAL.saPrint = function(...)
		print(...)
	end
else
	GLOBAL.saPrint = function() end
end
local saPrint = GLOBAL.saPrint

----------------------------------------------------------------------------------------------

local mods_id = {} --enabled mods are listed here for later use
for k,v in pairs(GLOBAL.ModManager.mods) do
	if v.modinfo then
		if v.modinfo.id then
			mods_id[v.modinfo.id] = true --ideally we want unique IDs rather than arbitrary names
		elseif v.modinfo.name then
			mods_id[v.modinfo.name] = true
		end
	end
end

require("cooking")
require("sa_nicknack")
local Image = require("widgets/image")
local pages1 = require("sa_recipes")
local pages2 = require("sa_spells")

----------------------------------------------------------------------------------------------
--COMMANDS & UTILITY
----------------------------------------------------------------------------------------------

local modmusic = nil
function GLOBAL.GetModMusicManager()
    if not modmusic then
		local player = GLOBAL.GetPlayer()
		if player then
			modmusic = player.components.modmusicmanager
		end
    end
    return modmusic
end

--[[GLOBAL.c_cc = function(name)
	GLOBAL.GetWorld().components.colourcubemanager:SetOverrideColourCube("images/colour_cubes/".. name .."_cc.tex")
end]]

GLOBAL.IsSentient = function(inst) --used by some soul-generating structures
	return inst.components.talker or inst:HasTag("ghost") or inst:HasTag("sentient")
end

GLOBAL.IsSoulless = function(inst) --used by most soul gear
	return inst.prefab == "wx78" or inst:HasTag("wall") or inst:HasTag("mech")
end

----------------------------------------------------------------------------------------------
--INTER-MOD
----------------------------------------------------------------------------------------------

if mods_id.tok then
	GLOBAL.MakeTome("abrew_recipes1",pages1[1],"book_tentacles")
	GLOBAL.MakeTome("abrew_recipes2",pages1[2],"book_brimstone")
	GLOBAL.MakeTome("abrew_recipes3",pages1[3],"book_gardening")
	GLOBAL.MakeTome("abrew_spells",pages2[1],"book_birds",nil,"FAR",.65,pages2[2],false)
	modimport("alchemylog.lua")
	AddPrefabPostInit("monkey",function(inst)
		inst.components.lootdropper:AddChanceLoot("abrew_spells",.15)
	end)
	AddPrefabPostInit("perd",function(inst)
		inst.components.lootdropper:AddChanceLoot("abrew_spells",.05)
	end)
else
	table.insert(PrefabFiles,"alchemylog") --dummy
end

----------------------------------------------------------------------------------------------
--ACTION
----------------------------------------------------------------------------------------------

--sip action
ACTIONS.DOPOTION = GLOBAL.Action(0,nil,true)
ACTIONS.DOPOTION.str = "Sip on"
ACTIONS.DOPOTION.id = "DOPOTION"
ACTIONS.DOPOTION.fn = function(act)
	local item = act.target or act.invobject
	if act.doer and act.doer.sg and item then
		--act.doer.sg:GoToState("quickeat")
		--act.doer.SoundEmitter:KillSound("eating") --silence the actual eat sound
		saPrint("Drank a potion")
		
		--item:DoTaskInTime(.35,function() --this function is actually pretty harmless :P
			if item.components.potionactions.onsip then
				item.components.potionactions.onsip(item,act.doer)
			end
			--if act.doer.SoundEmitter then
				--act.doer.SoundEmitter:PlaySound("dontstarve/HUD/sanity_up")
			--end
			
			if item.remaininguses then
				item.remaininguses = item.remaininguses - 1
				if item.remaininguses < 1 then
					item:Remove()
				end
			end
		--end)
		return true
	end
end

--Stategraph stuff
AddStategraphState("wilson", GLOBAL.State({
	name = "sip",
	tags = {"mod","busy"},
	onenter = function(inst)
		inst.components.locomotor:Stop()
		inst.AnimState:PlayAnimation("quick_eat")
	end,
	timeline = {
		TimeEvent(9*FRAMES, function(inst)
			if inst.SoundEmitter then --this is a bit earlier to be distinquishable
				inst.SoundEmitter:PlaySound("dontstarve/HUD/sanity_up") --gulp sound
			end
		end),
		TimeEvent(12*FRAMES, function(inst)
			inst:PerformBufferedAction()
		end),
	},
	events=
	{
		GLOBAL.EventHandler("animover", function(inst) inst.sg:GoToState("idle") end ),
	},
}))
AddStategraphActionHandler("wilson", GLOBAL.ActionHandler(ACTIONS.DOPOTION, "sip"))

----------------------------------------------------------------------------------------------
--SIM POST-INIT
----------------------------------------------------------------------------------------------

GLOBAL.PotionManager = {} --dummy

AddSimPostInit(function(inst)
	------------------------------------------------------------------------------------------
	--POTION MANAGER
	------------------------------------------------------------------------------------------
	local success = false
	for _,ent in pairs(Ents) do
		if ent.prefab == "potionmanager" then
			--saPrint("Found PotionManager instance in this world!")
			PotionManager = ent
			GLOBAL.PotionManager = PotionManager
			success = true
			break
		end
	end
	
	if not success then
		saPrint("Failed to find PotionManager instance in this world!")
		PotionManager = SpawnPrefab("potionmanager")
		GLOBAL.PotionManager = PotionManager
	end
	
	------------------------------------------------------------------------------------------
	--UI ELEMENTS
	------------------------------------------------------------------------------------------
	
	local wilson = GLOBAL.GetPlayer()
	if wilson and wilson.HUD then
		wilson.HUD.blindover = wilson.HUD.under_root:AddChild(Image("images/global.xml", "square.tex"))
		wilson.HUD.blindover:SetClickable(false) --blindover.inst:AddTag("NOCLICK")
		wilson.HUD.blindover:SetVRegPoint(ANCHOR_MIDDLE)
		wilson.HUD.blindover:SetHRegPoint(ANCHOR_MIDDLE)
		wilson.HUD.blindover:SetVAnchor(ANCHOR_MIDDLE)
		wilson.HUD.blindover:SetHAnchor(ANCHOR_MIDDLE)
		wilson.HUD.blindover:SetScaleMode(GLOBAL.SCALEMODE_FILLSCREEN)
		wilson.HUD.blindover:Hide() --blindover:SetTint(0,0,0,0)
		wilson.HUD.blindover.inst:AddComponent("fader")
		wilson.blindnessalpha = {}
	end
	
	------------------------------------------------------------------------------------------
	
	if wilson and not wilson.components.modmusicmanager then
		wilson:AddComponent("modmusicmanager")
	end
	
	GLOBAL.GetModMusicManager():AddTrack("soulfulalchemy/music/music_boss1", 2, 14)
end)

----------------------------------------------------------------------------------------------
--SOUL CRAFTING TREE
----------------------------------------------------------------------------------------------

modimport("branchadder.lua")

TUNING.PROTOTYPER_TREES.SOULBASIC = {
	SCIENCE = 0,
	MAGIC = 2,
	ANCIENT = 0,
	OBSIDIAN = 0,
	SOUL = 2,
},

AddTechBranch("SOUL", 2)

----------------------------------------------------------------------------------------------

--as of 1.2.1 we do this to make things better structured
modimport("strings.lua")
modimport("preconstructedeffects.lua")
modimport("ingredients.lua")
modimport("spells.lua")

----------------------------------------------------------------------------------------------

AddIngredientValues({"soulitem"}, {soul=1, monster = .5, inedible = .5})
AddIngredientValues({"soulitem_giant"}, {soul=5, monster = 1, inedible = .5})

----------------------------------------------------------------------------------------------
--RECIPES
----------------------------------------------------------------------------------------------

local ingr --for variable ingredients

if brewer_lvl == 1 then
	ingr = Ingredient("petals",4)
elseif brewer_lvl == 3 then
	ingr = Ingredient("manrabbit_tail",2)
elseif brewer_lvl == 4 then
	ingr = Ingredient("cookedmandrake",1)
else --lvl 2
	ingr = Ingredient("blue_cap",8)
end
local rec = Recipe("alchemydistiller",{Ingredient("tentaclespike",1),ingr,Ingredient("boards",1)},RECIPETABS.MAGIC,TECH.SCIENCE_TWO,"alchemydistiller_placer")
rec.atlas = "images/destiller.xml"
rec.image = "destiller.tex"

ingr = mods_id.irb and Ingredient("glass",1,"images/glass.xml") or Ingredient("spidergland",1)
rec = Recipe("alchemybottle",{Ingredient("messagebottleempty",1),ingr},RECIPETABS.MAGIC,TECH.SCIENCE_TWO)
rec.atlas = "images/alchemypotion.xml"
rec.image = "new.tex"

rec = Recipe("potiongun",{Ingredient("cutreeds",5),Ingredient("honey",2),Ingredient("twigs",3)},RECIPETABS.MAGIC,TECH.SCIENCE_TWO)
rec.atlas = "images/potiongun.xml"
rec.image = "potiongun.tex"

if mods_id.tok then
rec = Recipe("alchemylog",{Ingredient("papyrus",3),Ingredient("charcoal",2)},RECIPETABS.MAGIC,TECH.SCIENCE_TWO)
rec.image = "book_sleep.tex"
end

----

rec = {
	name = "soulcake",
	test = function(cooker, names, tags) return tags.soul and tags.veggie
	and not tags.meat end,
	priority = 10,
	weight = 2,
	foodtype = "VEGGIE",
	health = TUNING.HEALING_HUGE,
	hunger = -TUNING.CALORIES_LARGE *1.5,
	sanity = -TUNING.SANITY_TINY,
	perishtime = TUNING.PERISH_MED,
	cooktime = 1.5,
}
AddCookerRecipe("cookpot",rec)

rec = {
	name = "soulstew",
	test = function(cooker, names, tags) return tags.soul and tags.soul > 1
	and tags.meat and not tags.veggie end,
	priority = 10,
	weight = 3,
	foodtype = "MEAT",
	health = TUNING.HEALING_SUPERHUGE,
	hunger = TUNING.CALORIES_MEDSMALL,
	sanity = -TUNING.SANITY_HUGE,
	perishtime = TUNING.PERISH_SUPERFAST,
	cooktime = 3,
}
AddCookerRecipe("cookpot",rec)

--I think I know why the eyeturret has an item: structures can only be selected near the research station, and placer only appears when selected...
rec = Recipe("researchlab_soul_item",{Ingredient("boards",3),Ingredient("meat",1),Ingredient("petals_evil",2)},RECIPETABS.MAGIC,TECH.MAGIC_TWO,nil,nil,true)
rec.atlas = "images/soul/researchlab_soul_item.xml"
rec.image = "researchlab_soul_item.tex"

rec = Recipe("soulitem",{Ingredient("soulitem_giant",1,"images/soul/soulitem_giant.xml")},RECIPETABS.MAGIC,TECH.SOUL_2,nil,nil,true,6)
rec.atlas = "images/soul/soulitem.xml"
rec.image = "soulitem.tex"

rec = Recipe("dreamcatcher_item",{Ingredient("log",6),Ingredient("silk",3),Ingredient("feather_robin",4)},RECIPETABS.MAGIC,TECH.SOUL_2,nil,nil,true)
rec.atlas = "images/soul/dreamcatcher_item.xml"
rec.image = "dreamcatcher_item.tex"
rec = Recipe("hungryheart",{Ingredient("soulitem",9,"images/soul/soulitem.xml"),Ingredient("rope",2),Ingredient("hambat",1)},RECIPETABS.MAGIC,TECH.SOUL_2,nil,nil,true)
rec.atlas = "images/soul/hungryheart.xml"
rec.image = "hungryheart.tex"
rec = Recipe("starfisher",{Ingredient("soulitem",4,"images/soul/soulitem.xml"),Ingredient("twigs",6)},RECIPETABS.MAGIC,TECH.SOUL_2,nil,nil,true)
rec.atlas = "images/soul/starfisher.xml"
rec.image = "starfisher.tex"

rec = Recipe("soulhat",{Ingredient("soulitem_giant",1,"images/soul/soulitem_giant.xml"),Ingredient("healingsalve",8),Ingredient("strawhat",1)},RECIPETABS.MAGIC,TECH.SOUL_2,nil,nil,true)
rec.atlas = "images/soul/soulhat.xml"
rec.image = "soulhat.tex"
rec = Recipe("armorsoul",{Ingredient("soulitem",13,"images/soul/soulitem.xml"),Ingredient("pigskin",3),Ingredient("armorgrass",1)},RECIPETABS.MAGIC,TECH.SOUL_2,nil,nil,true)
rec.atlas = "images/soul/armorsoul.xml"
rec.image = "armorsoul.tex"

rec = Recipe("alchemysolvant",{Ingredient("soulitem",16,"images/soul/soulitem.xml"),Ingredient("rocks",10),Ingredient("turf_marsh",6)},RECIPETABS.MAGIC,TECH.SOUL_2,nil,nil,true)
rec.atlas = "images/alchemysolvant.xml"
rec.image = "alchemysolvant.tex"
rec = Recipe("resurrectionlapis_item",{Ingredient("soulitem_giant",1,"images/soul/soulitem_giant.xml"),Ingredient("rocks",10),Ingredient("butterflywings",1)},RECIPETABS.MAGIC,TECH.SOUL_2,nil,nil,true)
rec.atlas = "images/soul/resurrectionlapis_item.xml"
rec.image = "resurrectionlapis_item.tex"

rec = Recipe("spellcandle",{Ingredient("soulitem",1,"images/soul/soulitem.xml"),Ingredient("cutgrass",2),Ingredient("livinglog",1)},RECIPETABS.MAGIC,TECH.SOUL_2,nil,nil,true,2)
rec.atlas = "images/soul/spellcandle.xml"
rec.image = "spellcandle.tex"
