local require = GLOBAL.require
local Layouts = require("map/layouts").Layouts
local StaticLayout = require("map/static_layout")
require("map/terrain")
require("map/level")
require("map/tasks")

local terrain = GLOBAL.terrain
local tasklist = GLOBAL.tasks.sampletasks
local task_names = {}

for _, task in pairs(tasklist) do
   table.insert(task_names, task.id)
end

Layouts["abrewpreset1"] = StaticLayout.Get("map/static_layouts/abrewpreset1")
Layouts["abrewpreset2"] = StaticLayout.Get("map/static_layouts/abrewpreset2")
Layouts["abrewpreset3"] = StaticLayout.Get("map/static_layouts/abrewpreset3")

--This spawns several, but they kill each other until one is left
terrain.rooms.Barracks.contents.countprefabs = {potionreader = 1}

AddLevelPreInitAny(function(level)
	local chosen = {}
	if math.random() < .35 then --TUNE
		chosen["abrewpreset1"] = { count = 1, tasks = task_names }
	end
	if math.random() < .35 then --TUNE
		chosen["abrewpreset2"] = { count = 1, tasks = task_names }
	end
	if math.random() < .35 then --TUNE
		chosen["abrewpreset3"] = { count = 1, tasks = task_names }
	end
	
	if #chosen > 0 and not level.set_pieces then
		level.set_pieces = {}
	end
	for k,v in pairs(chosen) do
		level.set_pieces[k] = v
	end
end)