--mostly from starpotion.lua

local assets = {
	Asset("ANIM","anim/alchemypotion.zip"),
	
	Asset("IMAGE","images/alchemypotion.tex"),
	Asset("ATLAS","images/alchemypotion.xml"),
}

local prefabs =
{
    "shatter"
}

local function OnSave(inst,data)
	data.uses = inst.remaininguses
end

local function OnLoad(inst, data)
	inst.remaininguses = data.uses or 3
end

local function onsip(inst,doer)
	local guid = tostring(doer.GUID)
	if PotionManager and PotionManager.affected[guid] then
		for k, fx in pairs(PotionManager.affected[guid]) do
			PotionManager:WearOff(guid,fx,k)
		end
		PotionManager.affected[guid] = nil
	end
	inst.remaininguses = inst.remaininguses - 1
	if inst.remaininguses < 1 then
		inst:Remove()
	end
end

local function fn(inst)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	inst.AnimState:SetBank("alchemypotion")
	inst.AnimState:SetBuild("alchemypotion")
	inst.AnimState:PlayAnimation("p8")
	
    MakeInventoryPhysics(inst)
	
	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/alchemypotion.xml"
	inst.components.inventoryitem.imagename = "p8"
	
	inst.remaininguses = 3
	
	inst:AddComponent("potionactions")
	inst.components.potionactions.onsip = onsip
	
	inst:AddComponent("workable")
	inst.components.workable.onfinish = function(inst)
		local pt = inst:GetPosition()
		
		for k,v in pairs(TheSim:FindEntities(x,y,z,3,nil,{"FX","INLIMBO"})) do
			onsip(inst,v)
		end
		
		inst.SoundEmitter:PlaySound("dontstarve/creatures/egg/egg_cold_freeze")
		local shat = SpawnPrefab("shatter")
		shat.Transform:SetPosition(pt.x,pt.y,pt.z)
		shat.components.shatterfx:SetLevel(1)
		
		inst:Remove()
	end
	inst.components.workable.action = ACTIONS.HAMMER
	inst.components.workable:SetWorkLeft(1)
	
	inst.OnSave = OnSave
	inst.OnLoad = OnLoad
	
	inst:AddTag("alchemy")
	inst:AddTag("potion")
	inst:AddTag("magic")
	
	return inst
end

return Prefab( "common/inventory/antipotion",fn,assets,prefabs)