local assets = {
	Asset("ANIM", "anim/armor_sanity.zip"),
	Asset("ANIM", "anim/armorsoul.zip"),
}

local function RemoveGuard(inst)
	if inst.guard then
		inst.guard.sg:GoToState("dissipate")
		inst.guard = nil
	end
end

local function MakeGuard(inst)
	if inst.guard and not inst.guard.components.health:IsDead() then return end
	
	local pos = inst.components.inventoryitem.owner:GetPosition()
	inst.guard = SpawnPrefab("soulguard")
	inst.guard.Transform:SetPosition(pos.x,pos.y,pos.z)
	--inst.guard.sg:GoToState("appear")
	inst.guard.armor = inst
	inst.guard.components.follower:SetLeader(inst.components.inventoryitem.owner)
	
	if inst.guardhealth then
		inst.guard.components.health:SetVal(inst.guardhealth,"init")
		inst.guardhealth = nil
	end
end

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_body", "armorsoul", "swap_body")
	MakeGuard(inst)
end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
	inst.guardhealth = inst.guard and inst.guard.components.health.currenthealth
	RemoveGuard(inst)
end

local function OnSave(inst,data)
	if inst.guard and not inst.guard.components.health:IsDead() then
		data.guardhealth = inst.guard.components.health.currenthealth
	elseif inst.guardhealth then
		data.guardhealth = inst.guardhealth
	end
end

local function OnLoad(inst,data)
	if data and data.guardhealth then
		inst.guardhealth = data.guardhealth
		--[[inst:DoTaskInTime(0,function()
			if inst.components.equippable.isequipped and not inst.guard then
				MakeGuard(inst)
			end
		end)]]
	end
end

local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("armor_sanity")
    inst.AnimState:SetBuild("armorsoul")
    inst.AnimState:PlayAnimation("anim")
	
	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/soul/armorsoul.xml"
	
	inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY
	inst.components.equippable:SetOnEquip( onequip )
	inst.components.equippable:SetOnUnequip( onunequip )
	
	inst:AddComponent("armor")
	inst.components.armor:InitCondition(TUNING.ARMOR_SANITY, TUNING.ARMORWOOD_ABSORPTION)
	inst.components.armor.onfinished = function() RemoveGuard(inst) end
	
	inst.OnSave = OnSave
	inst.OnLoad = OnLoad
	
	inst:AddTag("sanity")
	inst:AddTag("soul")

	return inst
end

return Prefab("common/inventory/armorsoul",fn,assets)