local assets = {
    Asset("ANIM", "anim/hidingblindfold.zip"),
	Asset("ATLAS", "images/hidingblindfold.xml"),
}

local function onfinished(inst)
	inst:Remove()
end

local function onequip(inst, owner)
	--go blind and invisible
	POTIONEFFECTS.Blind(owner,{alpha=1,fadetime=0})
	POTIONEFFECTS.Invisible(owner,{})
	
	if inst.components.fueled then
		inst.components.fueled:StartConsuming()        
	end
end

local function onunequip(inst, owner)
	--undo blind and invisible
	POTIONWEAROFF.Blind(owner,{alpha=1,fadetime=0})
	POTIONWEAROFF.Invisible(owner,{})

	if inst.components.fueled then
		inst.components.fueled:StopConsuming()        
	end
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	MakeInventoryPhysics(inst)
	
	inst.AnimState:SetBank("hidingblindfold")
	inst.AnimState:SetBuild("hidingblindfold")
	inst.AnimState:PlayAnimation("anim")
	--inst.AnimState:SetMultColour(1,1,1,1)

	inst:AddComponent("inspectable")
	
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/hidingblindfold.xml"
	
	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
	inst.components.equippable:SetOnEquip( onequip )
	inst.components.equippable:SetOnUnequip( onunequip )
	
	inst:AddComponent("fueled")
	inst.components.fueled.fueltype = "USAGE"
	inst.components.fueled:InitializeFuelLevel(TUNING.TOTAL_DAY_TIME * 2)
	inst.components.fueled:SetDepletedFn(onfinished)
	
	MakeSmallBurnable(inst)
	MakeSmallPropagator(inst)
	
	--inst:AddTag("soul")
	inst:AddTag("hat")

	return inst
end

return Prefab("common/inventory/hidingblindfold",fn,assets,prefabs)