local assets = {
	Asset("ANIM","anim/alchemypotion.zip"),
	
	Asset("IMAGE","images/alchemypotion.tex"),
	Asset("ATLAS","images/alchemypotion.xml"),
}

local prefabs =
{
    "shatter"
}

local function fn(inst)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	inst.AnimState:SetBank("alchemypotion")
	inst.AnimState:SetBuild("alchemypotion")
	inst.AnimState:PlayAnimation("p9")
	
	inst.AnimState:SetRayTestOnBB(true)
	inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
	
    MakeInventoryPhysics(inst)
	
	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/alchemypotion.xml"
	inst.components.inventoryitem.imagename = "p9"
	
	inst:AddComponent("workable") --mostly from alchemypotion.lua
	inst.components.workable.onfinish = function(inst)
		local x,y,z = inst:GetPosition():Get()
		local ents = TheSim:FindEntities(x,y,z,3,nil,{"FX","INLIMBO"})
		for _, v in pairs(ents) do
			local new
			if v.components.combat then --characters
				PotionManager:Track(v,{name="Shield",strength=12,dur=38,args={val=.9,shields=5}},inst)
				POTIONEFFECTS["Ice"](v,{val=8},inst)
			elseif v.prefab:sub(1,4) == "rock" and v.prefab ~= "rock2"
			and v.components.workable and v.components.workable.action == ACTIONS.MINE
			and not v:HasTag("irreplaceable") then
				new = "rock2" --boulders
			elseif v.components.inventoryitem and not v.components.inventoryitem.owner
			and not v:HasTag("irreplaceable") and not v:HasTag("potion") then
				if PrefabExists("golden".. v.prefab) then
					new = "golden".. v.prefab --tools
				else
					new = "goldnugget" --items
				end
			end
			
			if new then
				local gold = SpawnPrefab(new)
				if gold and gold.Transform then
					gold.Transform:SetPosition(v:GetPosition():Get())
					v:Remove()
				end
			end
		end
		
		inst.SoundEmitter:PlaySound("dontstarve/creatures/egg/egg_cold_freeze")
		local shat = SpawnPrefab("shatter")
		shat.Transform:SetPosition(x,y,z)
		shat.components.shatterfx:SetLevel(1)
		
		inst:Remove()
	end
	inst.components.workable.action = ACTIONS.HAMMER
	inst.components.workable:SetWorkLeft(1)
	
	inst:AddComponent("tradable")
	inst.components.tradable.goldvalue = 7
	
	inst:AddTag("alchemy")
	inst:AddTag("potion")
	inst:AddTag("magic")
	
	return inst
end

return Prefab( "common/inventory/midaspotion",fn,assets,prefabs)