local Screen = require "screens/potionreader_screen"

local assets = {
	Asset("ANIM","anim/rock_flintless.zip"),
	
	--ugh
	Asset("ATLAS","images/potioneffects/heal.xml"),
	Asset("IMAGE","images/potioneffects/heal.tex"),
	Asset("ATLAS","images/potioneffects/damage.xml"),
	Asset("IMAGE","images/potioneffects/damage.tex"),
	Asset("ATLAS","images/potioneffects/regen.xml"),
	Asset("IMAGE","images/potioneffects/regen.tex"),
	Asset("ATLAS","images/potioneffects/poison.xml"),
	Asset("IMAGE","images/potioneffects/poison.tex"),
	Asset("ATLAS","images/potioneffects/acid.xml"),
	Asset("IMAGE","images/potioneffects/acid.tex"),
	Asset("ATLAS","images/potioneffects/fire.xml"),
	Asset("IMAGE","images/potioneffects/fire.tex"),
	Asset("ATLAS","images/potioneffects/ice.xml"),
	Asset("IMAGE","images/potioneffects/ice.tex"),
	Asset("ATLAS","images/potioneffects/temperature.xml"),
	Asset("IMAGE","images/potioneffects/temperature.tex"),
	Asset("ATLAS","images/potioneffects/combatstrength.xml"),
	Asset("IMAGE","images/potioneffects/combatstrength.tex"),
	Asset("ATLAS","images/potioneffects/runspeed.xml"),
	Asset("IMAGE","images/potioneffects/runspeed.tex"),
	Asset("ATLAS","images/potioneffects/insanity.xml"),
	Asset("IMAGE","images/potioneffects/insanity.tex"),
	Asset("ATLAS","images/potioneffects/sleep.xml"),
	Asset("IMAGE","images/potioneffects/sleep.tex"),
	Asset("ATLAS","images/potioneffects/light.xml"),
	Asset("IMAGE","images/potioneffects/light.tex"),
	Asset("ATLAS","images/potioneffects/shield.xml"),
	Asset("IMAGE","images/potioneffects/shield.tex"),
	Asset("ATLAS","images/potioneffects/blind.xml"),
	Asset("IMAGE","images/potioneffects/blind.tex"),
	Asset("ATLAS","images/potioneffects/invisible.xml"),
	Asset("IMAGE","images/potioneffects/invisible.tex"),
	Asset("ATLAS","images/potioneffects/fireimmune.xml"),
	Asset("IMAGE","images/potioneffects/fireimmune.tex"),
	Asset("ATLAS","images/potioneffects/iceimmune.xml"),
	Asset("IMAGE","images/potioneffects/iceimmune.tex"),
	Asset("ATLAS","images/potioneffects/grueimmune.xml"),
	Asset("IMAGE","images/potioneffects/grueimmune.tex"),
	Asset("ATLAS","images/potioneffects/blink.xml"),
	Asset("IMAGE","images/potioneffects/blink.tex"),
	Asset("ATLAS","images/potioneffects/slip.xml"),
	Asset("IMAGE","images/potioneffects/slip.tex"),
	Asset("ATLAS","images/potioneffects/explode.xml"),
	Asset("IMAGE","images/potioneffects/explode.tex"),
	Asset("ATLAS","images/potioneffects/colour.xml"),
	Asset("IMAGE","images/potioneffects/colour.tex"),
	Asset("ATLAS","images/potioneffects/summon.xml"),
	Asset("IMAGE","images/potioneffects/summon.tex"),
	Asset("ATLAS","images/potioneffects/thorns.xml"),
	Asset("IMAGE","images/potioneffects/thorns.tex"),
}

local function SpawnStuff(inst,i)
	if not inst then return end
	
	local guy
	local pos = inst:GetPosition()
	local offset = FindWalkableOffset(pos, math.random()*2*PI, 5, 8, true, false) -- try to avoid walls
	
	if offset then
		offset = pos + offset
		
		SpawnPrefab("lightning").Transform:SetPosition(offset:Get())

		
		if i and type(i) == "number" then
			guy = SpawnPrefab(inst.spawnables[i])
		else
			guy = SpawnPrefab(inst.spawnables[math.random(#inst.spawnables)])
		end
		
		if guy then
			guy.Transform:SetPosition(offset:Get())
			--if guy.components.combat then
				--guy.components.combat:SuggestTarget(wilson)
			--end
			if guy.components.explosive then
				guy.components.explosive:OnBurnt()
			end
		end
	end
	
	inst.components.lighttweener:StartTween(nil, 0, nil, nil, nil, .4)
end

local function TryScreen(inst,data)
	local wilson = GetPlayer()
	local brew = inst.components.container.slots[1]
	
	if wilson and brew and not (#brew.fx < 1) then
		--open the screen for Wilson
		TheFrontEnd:PushScreen(Screen(inst))
		
		--tween light
		inst.components.lighttweener:StartTween(nil, .8, nil, nil, nil, .4, SpawnStuff)
	end
end

local function itemtest(inst,item)
	return item and item.prefab == "alchemypotion"
end

local function OnOpen(inst,data)
	if data.doer and data.doer.HUD then
	data.doer.HUD.controls.containers[inst].inv[1].bgimage:SetTexture("images/potionslot.xml","potionslot.tex")
	end
	if GetWorld().components.feattrigger then
		GetWorld().components.feattrigger:Trigger("PotionReader")
	end
end

local function MakeUnique(inst)
	for k,v in pairs(Ents) do
		if v.prefab == inst.prefab and k < inst.GUID then
			inst:Remove()
		end
	end
end

local function fn(inst)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	inst.AnimState:SetBank("rock_flintless")
	inst.AnimState:SetBuild("rock_flintless")
	inst.AnimState:PlayAnimation("low")
	inst.AnimState:SetMultColour(1,.3,.6,.9)
	
	--MakeObstaclePhysics(inst, .8)
	
	inst:AddComponent("inspectable")
	
	inst:AddComponent("container")
	inst.components.container.numslots = 1
	inst.components.container.acceptsstacks = false
--	inst.components.container.type = "cooker"
--	inst.components.container.widgetanimbank = "ui_cookpot_1x4"
--	inst.components.container.widgetanimbuild = "ui_cookpot_1x4"
	inst.components.container.widgetslotpos = {Vector3(0,0,0)}
	inst.components.container.widgetpos = Vector3(-200,0,0)
	inst.components.container.side_align_tip = 100
--	inst.components.container.widgetbuttoninfo = widgetbuttoninfo
	inst.components.container.itemtestfn = itemtest
	inst:ListenForEvent("onopen",OnOpen)
	inst:ListenForEvent("itemget",TryScreen)
	
	inst:AddComponent("lighttweener")
	inst.entity:AddLight()
--[[	inst.Light:SetRadius(.8)
	inst.Light:SetIntensity(.4)
	inst.Light:SetFalloff(1)
	inst.Light:SetColour(.9,.8,1)
	inst.Light:Enable(true)]]
	inst.components.lighttweener:StartTween(inst.Light, 0, .4, 1, {.9,.8,1}, 0)
	
	inst:AddTag("rock")
	inst:AddTag("alchemy")
	
	inst.OnLoad = MakeUnique
	
	inst.spawnables = { --probability by quantity :P
		"tentacle_pillar_arm",
		"tentacle_pillar_arm",
		"tentacle_pillar_arm",
		"bat",
		"bat",
		"bat",
		"monkey",
		"monkey",
		"spider_hider",
		"spider_hider",
		"spider_hider",
		"spider_spitter",
		"spider_spitter",
		"crawlingnightmare",
		"crawlingnightmare",
		"nightmarebeak",
		"nightmarebeak",
		"slurtleslime",
		"slurtleslime",
		"redgem",
		"bluegem",
		"thulecite_pieces",
		"yellowamulet",
		"telestaff",
		"stafflight",
		"stafflight",
		"alchemybottle",
	}
	
	return inst
end

return Prefab("common/objects/potionreader", fn, assets)