local assets=
{
	Asset("ANIM", "anim/runicprojectile.zip"),
	--Asset("SOUND", "sound/chess.fsb"),
}

local function OnHit(inst, owner, target)
	inst.Physics:Stop()
	
	local fx = SpawnPrefab("mining_fx")
	fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
    fx.AnimState:SetMultColour(.35,.05,.10,1)
	
	inst.SoundEmitter:PlaySound("dontstarve/wilson/rock_break")
    
	inst.AnimState:PlayAnimation("disappear")
    inst:ListenForEvent("animover",inst.Remove)
end

local function SpawnRune(inst)
	local pos = inst:GetPosition()
	local offset = Vector3(math.random()-.5,3,math.random()-.5)
	--TODO ideally we want those to spawn slightly ahead of path, so they appear in time
	
	local fx = SpawnPrefab("runefx")
	fx.Transform:SetPosition((pos + offset):Get())
	
	inst:DoTaskInTime(math.random()*.3 + .2,SpawnRune)
end

local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	inst.Transform:SetFourFaced()
	
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)
    
    inst.AnimState:SetBank("runicprojectile")
    inst.AnimState:SetBuild("runicprojectile")
    inst.AnimState:PlayAnimation("idle", true)
    
	inst:AddTag("NOCLICK")
    inst:AddTag("projectile")
    inst.persists = false
    
    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(10)
    inst.components.projectile:SetHoming(false)
    inst.components.projectile:SetHitDist(1)
    inst.components.projectile:SetRange(20)
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(OnHit)
	
	--minor hack to allow this getting thrown without gun
	inst:AddComponent("weapon")
	inst.components.weapon:SetDamage(1) --set externally!
	
	inst:DoTaskInTime(math.random()*.3 + .2,SpawnRune)
	
    return inst
end

return Prefab( "common/inventory/runicprojectile", fn, assets)
