local assets = 
{
	Asset("ANIM", "anim/star.zip"),
	Asset("SHADER", "shaders/anim_souls.ksh"),
}

--Maybe I should use a HUD element for testing too

--It appears all shaders that work with items
--have a Matrix element at the beginning of the file

local shaders = {
	--THESE WORK ON STANDARD ISOMETRIC PREFABS
	--"shaders/anim.ksh",
	"shaders/anim_bloom.ksh",
	"shaders/anim_souls.ksh",
	--"shaders/anim_fade.ksh",
	--"shaders/particle.ksh",
	--"shaders/debug_line.ksh", --WARNING: MAKES SCREEN YELLOW
	--"shaders/debug_tri.ksh",
	--"shaders/wall_bloom.ksh", --WARNING: MAKES SCREEN YELLOW
	--"shaders/ui.ksh",
	--"shaders/ui_anim.ksh",
}

local function Toggle(inst)
    inst.task = nil
	if not inst.index or inst.index >= #shaders then
		inst.index = 1
	else
		inst.index = inst.index + 1
	end
	
	print("NEW SHADER:",shaders[inst.index])
	inst.AnimState:SetBloomEffectHandle(shaders[inst.index])
	
    inst.task = inst:DoTaskInTime(5, function() Toggle(inst) end)
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddPhysics()
    MakeInventoryPhysics(inst)

	--inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
	
    inst.AnimState:SetBank("star")
    inst.AnimState:SetBuild("star")
    inst.AnimState:PushAnimation("idle_loop", true)
	
	Toggle(inst)
	
    return inst
end

return Prefab( "common/shadertest", fn, assets) 
