local assets = {
	Asset("ANIM","anim/shieldfx.zip"),
}

local function Pop(inst)
	for _,v in pairs(inst.team) do
		--shrink
		--v:ListenForEvent("animover",function()
			v:Remove()
		--end)
	end
	inst:Remove()
end

local function GetTheta(inst)
	if inst.reverse then 
		inst.theta = inst.theta - .04
	else
		inst.theta = inst.theta + .04
	end
end

local function NextStep(inst)
	local pt = {}
	if inst.owner and inst.owner:IsValid() then
		if inst.owner.sg and inst.owner.sg:HasStateTag("invisible") then
			inst:Hide()
			inst.hidden = true
		elseif inst.hidden then
			inst:Show()
			inst.hidden = false
		end
		pt = inst.owner:GetPosition()
		pt.y = pt.y + (inst.height or 1)
		inst.Transform:SetPosition(pt.x,pt.y,pt.z)
	else
		Pop(inst)
		return
	end
	local radius = 1
	GetTheta(inst)
	local theta = inst.theta
	
	for _,v in pairs(inst.team) do
	
		local offset = Vector3(radius * math.cos(theta), 0, -radius * math.sin(theta))
		--v.nextpos = pt + offset
		offset = pt + offset
		--if distsq(offset, pt) > 0.10 then
			v.Transform:SetPosition(offset:Get())
		--end
		--print("Setting next step for Shield #".. _ ..":",v.nextpos:Get())
		theta = theta - (2 * PI/#inst.team)
	end
end

local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	inst.AnimState:SetBank("shieldfx")
	inst.AnimState:SetBuild("shieldfx")
	inst.AnimState:PlayAnimation("ring")
	inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    inst.AnimState:SetLayer(LAYER_BACKGROUND)
    inst.AnimState:SetSortOrder(3)
	inst.Transform:SetRotation(45)
	
	inst:AddTag("NOCLICK")
	inst:AddTag("FX")
	
	inst.persists = false
	
	--inst.AnimState:SetMultColour(1,1,1,.5)
	
	function inst:SpawnShields(num)		
		inst.team = {}
		inst.theta = 0
		for i = 1,num do
			local shield = SpawnPrefab("floatingshield")
			local pt = inst:GetPosition()
			shield.Transform:SetPosition(pt.x,pt.y,pt.z)
			shield.AnimState:SetMultColour(inst.AnimState:GetMultColour())
			table.insert(inst.team,shield)
			shield.sourcefx = inst
		end
	end
	
	inst.OnRemove = Pop
	
	inst:DoPeriodicTask(.01,NextStep)
	inst:DoTaskInTime(.5,function()
		if inst.owner then --assure we won't exist beyond the potion effect
			inst:ListenForEvent("potionworeoff",function() Pop(inst) end,inst.owner)
		end
	end)
	
	return inst
end

--[[local function UpdateShield(inst)
	inst.components.locomotor.walkspeed = GetPlayer().components.locomotor.walkspeed + 1
	if inst.sourcefx and inst.sourcefx.parent then
		if inst:GetDistSqToInst(inst.sourcefx.parent) < 16 then
			inst.components.locomotor.walkspeed = TUNING.WILSON_WALK_SPEED
		end
	end
	
	inst:DoSpin()
end]]

local function shieldfn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	inst.AnimState:SetBank("shieldfx")
	inst.AnimState:SetBuild("shieldfx")
	inst.AnimState:PlayAnimation("shield")
	
	inst:AddComponent("locomotor")
	
	inst:AddTag("NOCLICK")
	inst:AddTag("FX")
	
	inst.persists = false
	
--[[	function inst:DoSpin()
		local pt = Vector3(inst.Transform:GetWorldPosition())
		if inst.nextpos and pt then
			if distsq(inst.nextpos, pt) >= 0.15 then
				inst.components.locomotor:GoToPoint(inst.nextpos)
			else print("ERROR: TOO CLOSE") end
		else print("ERROR: NO NEXT STEP (OR OWN POSITION)") end
	end
	
	inst:DoPeriodicTask(.1,UpdateShield)]] --or just really often TP it?
	
	return inst
end

--cheating the thornsfx prefab in :P
local thorn_assets = 
{
	Asset("ANIM", "anim/thornsfx.zip")
}

local function thornsfn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	
	inst.AnimState:SetBank("thornsfx")
	inst.AnimState:SetBuild("thornsfx")
	inst.AnimState:PlayAnimation("anim")
	
	inst.Transform:SetScale(2,2,2)

	inst:AddTag("FX")
	inst.persists = false
	inst:ListenForEvent("animover", function() inst:Remove() end)

	return inst
end
	
return Prefab( "common/shieldfx", fn, assets),
	Prefab( "common/floatingshield", shieldfn, assets),
	Prefab( "common/thornsfx", thornsfn, thorn_assets)