local assets = {
	Asset("ANIM","anim/soulbombpotion.zip"),
	
	Asset("IMAGE","images/soul/soulbombpotion.tex"),
	Asset("ATLAS","images/soul/soulbombpotion.xml"),
}

local prefabs = {
    "shatter"
}

local function onhit(inst)
	local pos = inst:GetPosition()
	
	inst:Explode()
	
	inst.SoundEmitter:PlaySound("dontstarve/creatures/egg/egg_cold_freeze")
	local shat = SpawnPrefab("shatter")
	shat.Transform:SetPosition(pos.x,pos.y,pos.z)
	shat.components.shatterfx:SetLevel(1)
	
	inst:Remove()
end

local function fn(inst)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	inst.AnimState:SetBank("soulbombpotion")
	inst.AnimState:SetBuild("soulbombpotion")
	inst.AnimState:PlayAnimation("idle",true)
	
    MakeInventoryPhysics(inst)
	
	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/soul/soulbombpotion.xml"
	
	inst:AddComponent("workable")
	inst.components.workable.onfinish = onhit
	inst.components.workable.action = ACTIONS.HAMMER
	inst.components.workable:SetWorkLeft(1)
	
	function inst:Explode()
		local pt = inst:GetPosition()
		
		--maybe it's bad practise not to save the table in a variable
		for k,v in pairs(TheSim:FindEntities(pt.x,pt.y,pt.z, 5)) do
			if not (v.components.inventoryitem and v.components.inventoryitem:IsHeld())
			and v ~= inst then
				if v.components.workable and not v:HasTag("busy") then --Haaaaaaack!
					v.components.workable:WorkedBy(inst, 3)
				end
				
				PotionManager:Track(v,{name="Soulbite",strength=3,dur=26,args={chance=.8}},inst)
				if v.components.health and v.components.health:IsDead() then
					--better chance when killed directly
					if math.random() < .9 then
						local name = "soulitem"
						
						if v:HasTag("epic") then
							name = "soulitem_giant"
						elseif IsSoulless(v) then
							return
						end
						
						SpawnPrefab(name).Transform:SetPosition(v.Transform:GetWorldPosition())
					end
				end
				
				if v.components.combat and v ~= inst then
					v.components.combat:GetAttacked(inst,350)
				end
				
				v:PushEvent("explosion", {explosive = inst})
				if GetWorld() then
					GetWorld():PushEvent("explosion", {damage = 350})
				end
			end
		end
		
		local fx = SpawnPrefab("explode_small")
		fx.AnimState:SetMultColour(.1,.1,.1,1) --experimental
		fx.Transform:SetPosition(pt.x, pt.y, pt.z)
		fx.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
		fx.AnimState:SetLightOverride(1)
		
		inst.SoundEmitter:PlaySound("dontstarve/common/destroy_magic")
		
		GetClock():DoLightningLighting()
		GetPlayer().components.playercontroller:ShakeCamera(inst, "FULL", 0.7, 0.02, .5, 40)
	end
	
	inst:AddTag("alchemy")
	inst:AddTag("soul")
	inst:AddTag("potion")
	inst:AddTag("magic")
	
	return inst
end

return Prefab( "common/inventory/soulbombpotion",fn,assets,prefabs)