local assets = {
	Asset("ANIM","anim/nightmarefuel.zip"),
	Asset("ANIM","anim/soulitem.zip"),
	
	Asset("IMAGE","images/soul/soulitem.tex"),
	Asset("ATLAS","images/soul/soulitem.xml"),
	Asset("IMAGE","images/soul/soulitem_giant.tex"),
	Asset("ATLAS","images/soul/soulitem_giant.xml"),
}

local function FillHole(inst,grave,donor)
	if grave.ResetGrave then
		local pt = grave:GetPosition()
		
		grave:ResetGrave()
		inst.SoundEmitter:PlaySound("dontstarve/common/place_ground")
		
		local fx = SpawnPrefab("maxwell_smoke")
		fx.Transform:SetPosition(pt.x,pt.y,pt.z)
		
		fx = SpawnPrefab("sanity_raise")
		fx.Transform:SetPosition(pt.x,pt.y,pt.z)
		fx.AnimState:SetAddColour(1,1,1,.6)
	end
end

local function common(inst)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	MakeInventoryPhysics(inst)
	
	inst.AnimState:SetBank("nightmarefuel")
	inst.AnimState:SetBuild("soulitem")
	inst.AnimState:PlayAnimation("idle_loop", true)
	
	inst.AnimState:SetMultColour(1,1,1,.1)
    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
	
	inst:AddComponent("inventoryitem")
	inst:AddComponent("stackable")
	
	inst:AddComponent("inspectable")
	
	inst:AddComponent("potionbrewable")
	
	inst:AddTag("soul")
	inst:AddTag("soulitem")
	
	return inst
end

local function fn(inst)
	local inst = common()
	
	inst.Transform:SetScale(.75,.75,.75)
	
	inst.components.inventoryitem.atlasname = "images/soul/soulitem.xml"
	
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_MEDITEM
	
	inst.components.potionbrewable:AddEffect("Soulbite",2,{chance=.5},20)
	inst.components.potionbrewable:AddEffect("GrueImmune",0,{shields=1},18,{
		Damage = true,
		Poison = true,
		Acid = true,
		Fire = true,
		Insanity = true,
		Light = true,
		Blind = true,
		IceImmune = true,
		Blink = true,
		Slip = true,
		Explode = true,
	},{
		{name="Sleep",strength=2,args={val=3}},
		{name="Poison",strength=3,dur=23,anti={
			Heal = true,
		}},
	})
	inst.components.potionbrewable.tags = {soul = 1}
	
	if IsDLCEnabled(REIGN_OF_GIANTS) then
		inst:AddComponent("buryable")
		inst.components.buryable:SetOnBury(FillHole)
	end
	
	return inst
end

local function fn2(inst)
	local inst = common()
	
	inst.components.inventoryitem.atlasname = "images/soul/soulitem_giant.xml"
	
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_LARGEITEM
	
	inst.components.potionbrewable:AddEffect("Soulbite",4,{soul="soulitem_giant"},34)
	inst.components.potionbrewable:AddEffect("RunSpeed",3,{val=-2},39,{
		Temperature = true,
		Ice = true,
		Blind = true,
	},{
		{name="Blink",strength=3,args={minr=12,maxr=16}},
	})
	inst.components.potionbrewable:AddEffect("CombatStrength",6,{val=38},42,{
		Temperature = true,
		Fire = true,
		Invisible = true,
	},{
		{name="Shield",strength=4,args={val=.5,shields=3},dur=40},
	})
	inst.components.potionbrewable.tags = {soul = 4,precious = 2}
	
	return inst
end

return Prefab("common/inventory/soulitem", fn, assets),
	Prefab("common/inventory/soulitem_giant", fn2, assets)