--mostly from midaspotion.lua

local assets = {
	Asset("ANIM","anim/alchemypotion.zip"),
	
	Asset("IMAGE","images/alchemypotion.tex"),
	Asset("ATLAS","images/alchemypotion.xml"),
}

local prefabs =
{
    "shatter"
}

local function fn(inst)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	
	inst.AnimState:SetBank("alchemypotion")
	inst.AnimState:SetBuild("alchemypotion")
	inst.AnimState:PlayAnimation("p5")
	
	inst.AnimState:SetRayTestOnBB(true)
	inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
	
	inst.entity:AddLight()
    inst.Light:SetFalloff(.4)
    inst.Light:SetIntensity(.4)
    inst.Light:SetRadius(.3)
    inst.Light:SetColour(.7,.5,.2)
	
    MakeInventoryPhysics(inst)
	
	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/alchemypotion.xml"
	inst.components.inventoryitem.imagename = "p5"
	
	inst:AddComponent("workable")
	inst.components.workable.onfinish = function(inst)
		local x,y,z = inst:GetPosition():Get()
		local star = SpawnPrefab("stafflight")
		star.Transform:SetPosition(x,y,z)
		
		inst.SoundEmitter:PlaySound("dontstarve/creatures/egg/egg_cold_freeze")
		local shat = SpawnPrefab("shatter")
		shat.Transform:SetPosition(x,y,z)
		shat.components.shatterfx:SetLevel(1)
		
		inst:Remove()
	end
	inst.components.workable.action = ACTIONS.HAMMER
	inst.components.workable:SetWorkLeft(1)
	
	inst:AddTag("alchemy")
	inst:AddTag("potion")
	inst:AddTag("magic")
	
	return inst
end

return Prefab( "common/inventory/starpotion",fn,assets,prefabs)