chestfunctions = require("scenarios/chestfunctions")

local function OnCreate(inst, scenariorunner)
	local loot = {
		{
			item = "potiongun",
			count = 1,
		},
		{
			item = "livinglog",
			count = 3,
		},
		{
			item = "feather_robin_winter",
			count = 2,
		},
	}
	
	chestfunctions.AddChestItems(inst, loot)
end

local talkabouttrap = function(inst)
	if inst.components.talker then
		inst.components.talker:Say(GetString(inst.prefab, "ANNOUNCE_TRAP_WENT_OFF"))
	end
end
		
local function Trigger(inst,data)
	local player = data and (data.opener or data.worker) or GetPlayer()
	
	inst.SoundEmitter:PlaySound("dontstarve/common/chest_trap")
	
	local fx = SpawnPrefab("statue_transition_2")
	if fx then
		fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
		fx.AnimState:SetScale(1,2,1)
	end
	fx = SpawnPrefab("statue_transition")
	if fx then
		fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
		fx.AnimState:SetScale(1,1.5,1)
	end
	
	inst:DoTaskInTime(.5,function()
		if GetSeasonManager() then
			GetSeasonManager():DoLightningStrike(inst:GetPosition())
		end
	end)
	player:DoTaskInTime(1, talkabouttrap)
	
	inst.scenariorunner:ClearScenario()
	inst:destroyscenario()
end

local function OnDestroy(inst)
	inst:RemoveEventCallback("onopen",Trigger)
	inst:RemoveEventCallback("worked",Trigger)
end

local function OnLoad(inst, scenariorunner)
	inst.scenariorunner = scenariorunner
	inst.destroyscenario = OnDestroy
	inst:ListenForEvent("onopen",Trigger)
	inst:ListenForEvent("worked",Trigger)
end

return {
	OnCreate = OnCreate,
	OnLoad = OnLoad,
}